# EKKINISH (Edo theoritika den allazoyme kamia grammi kodika)
from __future__ import division
from visual import *
from physutil import *
import csv

# Kodikas gia tin grafiki anaparastasi toy montelou
# ===========================================

# Arxikopoiisi parathirou gia anaparastasi
graph = PhysGraph(1)
# Arxikopoiisi parathirou gia optikopoiisi
scene = display(width = 640, height = 480, background = color.white, range = 2.5, title = "VPython Test")
# Dimiourgia antikeimenou gia montelopoiisi
ball = sphere(color = color.red, radius = 0.12)
# Dimiourgia tis troxias poy diagrafei to antikeimeno
trail = curve(color = color.green, radius = 0.02)
# Dimiourgia antikeimenou poy anaparista to antikeimeno tou peiramatos
origin = sphere(pos=vector(0,0,0), color = color.yellow, radius = 0.04)


# IDIOTITES SYSTHMATOS KAI ARXIKES PROYPOTHESEIS
# ===========================================

# Maza systimatos
# Tin parakato grammi mporeite na tin allajete
ball.m = 950

# Arxikes proypotheseis
# Tis parakato treis grammes mporeite na tis allajete
ball.pos = vector(+0.048,0,0)
ball.vel = vector(+19.8,0,0)
t = 0  #     


# Alles arxikopoiiseis
# ==========================================
#
# Bima xronou dt
# Tin parakato grammi mporeite na tin allajete
deltat = 0.01

# PROERETIKA: Problepsis toy montelou apothikeyontai se arxeio me proektasi .csv 
# Gia na ginei xrisi autis tis dinatotitas afaireite to # apo tin epomeni
outputfile = open('pythonTest.csv', 'wb') # Kathorismos toy onomatos toy arxeioy
                                          # Ean to arxeio yparxei tha diagrafei                               
DataWriter = csv.writer(outputfile, delimiter=',', quotechar='|', quoting=csv.QUOTE_MINIMAL) #  
DataWriter.writerow(['Time (s)','Position (m)']) # Eggrafi epikefalidas gia xrono kai thesi


# BROXOS EPANALIPSIS (Problepsi kinisis kai optiki anaparastasi)
# ===========================================
while t < 0.833:
    # Ypologismos tis synistamenis dinamis
    # Tin parakato grammi mporeite na tin allajete
    Fnet=vector(0,0,0)
    # Deyteros nomos tou Neytona (problepsi-ypologismos tis taxytitas)
    # Tin parakato grammi mporeite na tin allajete
    ball.vel = ball.vel + (Fnet/ball.m)*deltat
    # problepsi-ypologismos tis thesis
    # Tin parakato grammi mporeite na tin allajete
    ball.pos = ball.pos + ball.vel*deltat
    # Auksisi toy xronoy kata dt
    t = t + deltat

     
    # Enimerosi tis troxias toy antikeimenou
    trail.append(pos = ball.pos)
    # Dimiourgia tis grafikis parastasis thesis-xronou
    # Tin parakato grammi mporeite na tin allajete

    graph.plot(t,ball.pos.x)

    # Gia na epitaxynetai i na epibradinetai tin ektelesi toy programmatos
    # Tin parakato grammi mporeite na tin allajete (megalyteros arithmos, grigoroteri ektelesi)
    rate(100)

    # Gia na epitaxynetai i na epibradinetai tin ektelesi toy programmatos
    # Tin parakato grammi mporeite na tin allajete (megalyteros arithmos, grigoroteri ektelesi)
    DataWriter.writerow([str(t),str(ball.pos.x)])


print(t,ball.pos.x)


# PROERETIKA: Problepsis toy montelou apothikeyontai se arxeio me proektasi .csv 
# Gia na ginei xrisi autis tis dinatotitas afaireite to # apo tin epomeni grammi 
outputfile.close()
